removes unsound cases, adds unrolling
[cvc5.git] / Makefile
1 # -*-makefile-*-
2 #
3 # This makefile is the _source_ directory's makefile, and is static,
4 # not generated. Makefile.am is the automake makefile for the build
5 # top-level (its corresponding Makefile.in is here, too, but the
6 # corresponding Makefile is under builds/$arch/$buildid.
7 #
8 builddir = builds
9
10 .PHONY: all install examples install-examples
11 all install examples install-examples .DEFAULT:
12 @if test -d $(builddir); then \
13 echo cd $(builddir); \
14 cd $(builddir); \
15 echo $(MAKE) $@; \
16 $(MAKE) $@ || exit 1; \
17 $(MAKE) show-config; \
18 else \
19 echo; \
20 echo 'Run configure first, or type "make" in a configured build directory.'; \
21 echo; \
22 fi
23
24 distclean maintainerclean:
25 @if test -d $(builddir); then \
26 echo cd $(builddir); \
27 cd $(builddir); \
28 echo $(MAKE) $@; \
29 $(MAKE) $@ || exit 1; \
30 fi
31 test -z "$(builddir)" || rm -fr "$(builddir)"
32 rm -f config.reconfig
33
34 # synonyms for "check"
35 .PHONY: test
36 test: check
37
38 .PHONY: doc doc-internals
39 doc: doc-builds
40 doc-internals: doc-internals-builds
41
42 YEAR := $(shell date +%Y)
43 submission submission-main:
44 @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
45 echo 'ERROR:' >&2; \
46 echo 'ERROR: Please make maintainer-clean first.' >&2; \
47 echo 'ERROR:' >&2; \
48 exit 1; \
49 fi
50 ./autogen.sh
51 ./configure competition --disable-shared --enable-static-binary --with-cln --with-glpk
52 $(MAKE)
53 strip builds/bin/cvc4
54 $(MAKE) check
55 $(MAKE) -C test/regress/regress1 check
56 # main track
57 mkdir -p cvc4-smteval-$(YEAR)
58 cp -p builds/bin/cvc4 cvc4-smteval-$(YEAR)/cvc4
59 cp contrib/run-script-smteval2013 cvc4-smteval-$(YEAR)/run
60 chmod 755 cvc4-smteval-$(YEAR)/run
61 tar cf cvc4-smteval-$(YEAR).tar cvc4-smteval-$(YEAR)
62 submission-application:
63 # application track is a separate build because it has different preprocessor #defines
64 @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
65 echo 'ERROR:' >&2; \
66 echo 'ERROR: Please make maintainer-clean first.' >&2; \
67 echo 'ERROR:' >&2; \
68 exit 1; \
69 fi
70 ./autogen.sh
71 ./configure competition --disable-shared --enable-static-binary --with-cln --with-glpk CXXFLAGS=-DCVC4_SMTCOMP_APPLICATION_TRACK CFLAGS=-DCVC4_SMTCOMP_APPLICATION_TRACK
72 $(MAKE)
73 strip builds/bin/cvc4
74 $(MAKE) check
75 $(MAKE) -C test/regress/regress1 check
76 # package the application track tarball
77 mkdir -p cvc4-application-smteval-$(YEAR)
78 cp -p builds/bin/cvc4 cvc4-application-smteval-$(YEAR)/cvc4
79 ( echo '#!/bin/sh'; \
80 echo 'exec ./cvc4 -L smt2 --no-checking --no-interactive --incremental' ) > cvc4-application-smteval-$(YEAR)/run
81 chmod 755 cvc4-application-smteval-$(YEAR)/run
82 tar cf cvc4-application-smteval-$(YEAR).tar cvc4-application-smteval-$(YEAR)
83 submission-parallel:
84 # parallel track can't be built with -cln, so it's a separate build
85 @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
86 echo 'ERROR:' >&2; \
87 echo 'ERROR: Please make maintainer-clean first.' >&2; \
88 echo 'ERROR:' >&2; \
89 exit 1; \
90 fi
91 ./autogen.sh
92 ./configure competition --disable-shared --enable-static-binary --with-gmp --with-portfolio --with-glpk
93 $(MAKE)
94 strip builds/bin/pcvc4
95 # some test cases fail (and are known to fail)
96 -$(MAKE) check BINARY=pcvc4
97 $(MAKE) -C test/regress/regress1 check BINARY=pcvc4
98 # package the parallel track tarball
99 mkdir -p cvc4-parallel-smteval-$(YEAR)
100 cp -p builds/bin/pcvc4 cvc4-parallel-smteval-$(YEAR)/pcvc4
101 ( echo '#!/bin/sh'; \
102 echo 'exec ./pcvc4 --threads 2 -L smt2 --no-checking --no-interactive' ) > cvc4-parallel-smteval-$(YEAR)/run
103 chmod 755 cvc4-parallel-smteval-$(YEAR)/run
104 tar cf cvc4-parallel-smteval-$(YEAR).tar cvc4-parallel-smteval-$(YEAR)